b17{
	var{
		b17/map/map
		screen_width  = 15
		screen_height = 15
		b17/player/player
		datum/call_back
		call_back_function
		}
	proc{
		launch(var/client/who, var/datum/callback, callback_function as text, swidth as num, sheight as num){
			ASSERT(hascall(callback, callback_function))
			call_back = callback
			call_back_function = callback_function
			if(swidth ){ screen_width  = swidth }
			if(sheight){ screen_height = sheight}
			map = new(screen_width,screen_height)
			var/b17/map/tile/T = locate(
				round(screen_width/2)+1,
				round(screen_height/2)+map.play_field.y,
				world.maxz
				)
			player = new(T, src)
			who.eye = T
			who.mob = player
			}
		end(){
			call(call_back, call_back_function)(player.client)
			player.dispose()
			map.dispose()
			}
		}
	}
b17/map{
	parent_type = /datum
	var{
		screen_width
		screen_height
		b17/map/buffer/creation/creation
		b17/map/buffer/deletion/deletion
		b17/map/buffer/c_border/c_border
		b17/map/buffer/d_border/d_border
		b17/map/buffer/play_field/play_field
		b17/map/buffer/side_border/side_border
		}
	New(swidth as num, sheight as num){
		screen_width  = swidth
		screen_height = sheight
		world.maxz++
		creation    = new()
		deletion    = new()
		c_border    = new()
		d_border    = new()
		play_field  = new()
		side_border = new()
		play_field.height = screen_height
		var/total_height = creation.height + deletion.height + c_border.height + d_border.height + play_field.height
		world.maxy = max(world.maxy, total_height  )
		world.maxx = max(world.maxx, screen_width+1)
		for(var/x_position = 1 to screen_width){
			for(var/y_position = 1 to total_height){
				new /b17/map/tile(locate(x_position, y_position, world.maxz))
				}
			for(var/y_position = 1 to deletion.height){
				var/b17/map/tile/T = locate(x_position, y_position, world.maxz)
				deletion.contents.Add(T)
				}
			for(var/y_position = 1 to d_border.height){
				var/offset = deletion.height
				var/b17/map/tile/T = locate(x_position, y_position+offset, world.maxz)
				d_border.contents.Add(T)
				}
			for(var/y_position = 1 to play_field.height){
				var/offset = deletion.height + d_border.height
				var/b17/map/tile/T = locate(x_position, y_position+offset, world.maxz)
				play_field.contents.Add(T)
				}
			for(var/y_position = 1 to c_border.height){
				var/offset = deletion.height + d_border.height + play_field.height
				var/b17/map/tile/T = locate(x_position, y_position+offset, world.maxz)
				c_border.contents.Add(T)
				}
			for(var/y_position = 1 to creation.height){
				var/offset = deletion.height + d_border.height + play_field.height + c_border.height
				var/b17/map/tile/T = locate(x_position, y_position+offset, world.maxz)
				creation.contents.Add(T)
				}
			}
		for(var/y_position = 1 to total_height){
			var/b17/map/tile/T = new(locate(screen_width+1, y_position, world.maxz))
			side_border.contents.Add(T)
			}
		}
	proc/dispose(){
		creation.dispose()
		deletion.dispose()
		c_border.dispose()
		d_border.dispose()
		play_field.dispose()
		side_border.dispose()
		Del()
		}
	tile{
		parent_type = /turf
		icon = 'interface.dmi'
		icon_state = "clear"
		density = 0
		}
	buffer{
		parent_type = /area
		icon = 'interface.dmi'
		density = 0
		var{
			height
			}
		proc/dispose(){
			for(var/atom/A in contents){
				del A
				}
			Del()
			}
		creation{
			icon_state = "creation"
			height = 4
			var{
				rounds = 0
				}
			Enter(){ return FALSE}
			New(){
				set waitfor = FALSE
				.=..()
				while(TRUE){
					rounds++
					sleep(max(5, 30-round(rounds/3)))
					var/atom/A = pick(contents)
					if(!istype(A, /b17/map/tile)){ continue}
					var/target_type = pick(             \
						/b17/particle/aircraft/fw190  , \
						/b17/particle/aircraft/bf110  , \
						/b17/particle/target/flack_gun, \
						/b17/particle/target/flack_gun, \
						/b17/particle/target/flack_gun, \
						/b17/particle/target/factory    \
						)
					new target_type(A)
					}
				}
			}
		deletion{
			icon_state = "deletion"
			height = 1
			Entered(var/atom/movable/M){
				.=..()
				del M
				}
			}
		c_border{
			icon_state = "c_border"
			height = 2
			Enter(var/atom/movable/M){
				if(istype(M, /b17/particle/target)){
					var/b17/particle/target/T = M
					T.activate()
					return ..()
					}
				else if(!istype(M, /b17/player)){
					return ..()
					}
				}
			}
		d_border{
			icon_state = "d_border"
			height = 5
			Enter(var/atom/movable/M){
				if(!istype(M, /b17/player)){
					return ..()
					}
				}
			}
		play_field{
			icon_state = "black"
			}
		side_border{
			icon_state = "side_border"
			density = 1
			Enter(){ return FALSE}
			}
		}
	}
b17/particle{
	parent_type = /mob
	density = 0
	animate_movement = SLIDE_STEPS
	proc{
		hit(){}
		dispose(){
			del src
			}
		}
	target{
		animate_movement = 1
		pixel_step_size = 4
		layer = TURF_LAYER
		icon_state = "good"
		density = 0
		var{
			destroyed = FALSE
			}
		New(){
			.=..()
			walk(src, SOUTH, 32/pixel_step_size)
			}
		hit(){
			destroyed = TRUE
			flick("explode",src)
			spawn(10){
				dispose()
				}
			}
		proc{
			activate(){
				}
			}
		flack_gun{
			icon = 'flack_gun.dmi'
			activate(){
				set waitfor = FALSE
				. = TRUE
				while(!destroyed){
					var/b17/player/player = (locate(/b17/player) in range(6,src))
					if(player){
						if(     player.x > x){ icon_state = "good_east"}
						else if(player.x < x){ icon_state = "good_west"}
						else{                  icon_state = "good"     }
						new /b17/particle/target/flack_gun/shell(loc,player.loc)
						}
					sleep(20)
					}
				}
			shell{
				parent_type = /b17/particle
				icon = 'flack_gun.dmi'
				icon_state = "shell"
				layer = OBJ_LAYER
				New(newloc, end_loc){
					set waitfor = FALSE
					.=..()
					flick("shell",src)
					var/temp = get_dist(src,end_loc)+1
					pixel_step_size = 32 / temp
					walk_towards(src,end_loc,temp)
					icon_state = ""
					sleep(32)
					pixel_step_size = 4
					layer = MOB_LAYER + 1
					icon_state = "shell_explode"
					for(var/b17/player/P in range(1,src)){
						P.hit()
						}
					step(src,SOUTH)
					walk(src,SOUTH, 32/pixel_step_size)
					sleep(5)
					for(var/b17/player/P in range(1,src)){
						P.hit()
						}
					sleep(5)
					dispose()
					}
				}
			}
		factory{
			icon = 'factory.dmi'
			layer = OBJ_LAYER
			var{
				list/parts
				}
			part{
				parent_type = /obj
				animate_movement = SYNC_STEPS
				icon = 'factory.dmi'
				layer = TURF_LAYER
				}
			New(){
				.=..()
				parts = new()
				for(var/xpos = 0 to 1){
					for(var/ypos = 0 to 1){
						var/b17/particle/target/factory/part/P = new(loc)
						var/position = "[xpos],[ypos]"
						P.icon_state = position
						P.pixel_x = -16 + xpos*32
						P.pixel_y = -16 + ypos*32
						parts[position] = P
						}
					}
				}
			Move(){
				.=..()
				for(var/position in parts){
					var/b17/particle/target/factory/part/P = parts[position]
					P.loc = loc
					}
				}
			dispose(){
				for(var/position in parts){
					var/b17/particle/target/factory/part/P = parts[position]
					del P
					}
				if(rand()*3 >= 2){
					var/p_type = pick(typesof(/b17/particle/powerup) - /b17/particle/powerup)
					new p_type(loc)
					}
				.=..()
				}
			}
		}
	aircraft{
		density = 1
		layer = MOB_LAYER
		bullet{
			parent_type = /b17/particle
			pixel_step_size = 16
			icon = 'bf110.dmi'
			icon_state = "bullet"
			density = 1
			New(){
				.=..()
				step(src,SOUTH)
				walk(src,SOUTH,32/pixel_step_size)
				}
			Bump(var/b17/player/what){
				if(istype(what,/b17/player)){
					what.hit()
					}
				Del()
				}
			}
		fw190{
			icon = 'fw190.dmi'
			pixel_step_size = 16
			New(){
				.=..()
				walk(src,SOUTH,32/pixel_step_size)
				}
			Bump(var/b17/player/what){
				if(istype(what,/b17/player)){
					what.hit()
					density = 0
					icon_state = "explode"
					step(src,SOUTH)
					}
				else{
					Del()
					}
				}
			}
		bf110{
			icon = 'bf110.dmi'
			pixel_step_size = 4
			dir = SOUTH
			New(){
				.=..()
				walk(src,SOUTH,32/pixel_step_size)
				}
			Move(newloc, newdir){
				if(density){
					newdir = pick(dir, SOUTH, SOUTHWEST, SOUTHEAST)
					newloc = get_step(loc,newdir)
					if(rand()*4 >= 3){
						new /b17/particle/aircraft/bullet(src.loc)
						}
					.=..(newloc,newdir)
					}
				else{
					.=..()
					}
				}
			}
		}
	powerup{
		layer = FLY_LAYER
		icon = 'powerup.dmi'
		icon_state = "extra"
		animate_movement = 1
		pixel_step_size = 4
		density = 0
		New(){
			.=..()
			walk(src, SOUTH, 32/pixel_step_size)
			}
		Move(){
			.=..()
			var/b17/player/player = (locate(/b17/player) in range(1,src))
			if(player){ activate(player)}
			}
		proc{
			activate(var/b17/player/who){
				del src
				}
			}
		invulnerable{
			icon_state = "shield"
			activate(var/b17/player/who){
				who.invulnerable(override = TRUE)
				.=..()
				}
			}
		health{
			icon_state = "health"
			activate(var/b17/player/who){
				who.heal()
				.=..()
				}
			}
		}
	}
b17/player{
	parent_type = /b17/particle/aircraft
	sight = SEE_PIXELS
	icon = 'b17.dmi'
	icon_state = "good"
	layer = MOB_LAYER + 1
	var{
		b17/game
		list/parts
		body = 3
		invulnerable
		}
	New(newloc, var/b17/_game){
		game = _game
		.=..()
		parts = new()
		for(var/xpos = 0 to 1){
			for(var/ypos = 0 to 1){
				var/b17/player/part/P = new(loc)
				var/position = "[xpos],[ypos]"
				P.icon_state = position
				P.pixel_x = -16 + xpos*32
				P.pixel_y = -16 + ypos*32
				parts[position] = P
				}
			}
		}
	Move(){
		.=..()
		for(var/position in parts){
			var/b17/player/part/P = parts[position]
			P.loc = loc
			}
		}
	part{
		parent_type = /obj
		animate_movement = SYNC_STEPS
		icon = 'b17.dmi'
		layer = MOB_LAYER
		}
	verb/drop_bomb(){
		new /b17/player/bomb(loc)
		}
	bomb{
		parent_type = /b17/particle
		icon = 'b17.dmi'
		icon_state = "bomb_drop"
		layer = OBJ_LAYER
		New(newloc, end_loc){
			set waitfor = FALSE
			.=..()
			icon_state = ""
			flick("bomb_drop",src)
			sleep(40)
			pixel_step_size = 4
			layer = TURF_LAYER
			icon_state = "explode"
			for(var/b17/particle/target/T in range(1,src)){
				T.hit()
				}
			step(src,SOUTH)
			walk(src,SOUTH, 32/pixel_step_size)
			sleep(10)
			dispose()
			}
		}
	hit(){
		if(invulnerable){ return}
		body = max(0,body-1)
		switch(body){
			if(3){
				icon_state = "good"
				invulnerable()
				}
			if(2){
				icon_state = "smoke"
				invulnerable()
				}
			if(1){
				icon_state = "fire"
				invulnerable()
				}
			if(0){
				die()
				}
			}
		}
	proc{
		die(){
			set waitfor = FALSE
			. = FALSE
			icon_state = "explode"
			sleep(20)
			game.end()
			}
		invulnerable(override){
			if(invulnerable && (!override)){ return}
			invulnerable = world.time
			var/change_notifier = invulnerable
			for(var/position in parts){
				var/b17/player/part/P = parts[position]
				P.icon_state = "[position]_invulnerable"
				}
			spawn(override? 60 : 25){
				if(invulnerable != change_notifier){ return}
				for(var/position in parts){
					var/b17/player/part/P = parts[position]
					P.icon_state = position
					}
				spawn(5){
					if(invulnerable != change_notifier){ return}
					invulnerable = FALSE
					}
				}
			}
		heal(){
			body = 3
			icon_state = "good"
			}
		}
	}